#include <iostream>
#include <queue>
using namespace std;

queue<int> q;
char b[20001], v[5001];
int g[5010][5010];
int a[5100], n, maxg = 0;

void gossip( int p )
{
     int i, l, gos = 0;

     v[p] = 1;
     q.push( p );
     
     while ( ! q.empty() )
     {
         gos++;
         l = q.front();
         q.pop();
         
         for ( i = 1; i <= g[l][0]; i++ )
             if ( v[g[l][i]] == 0 )
             {
                 v[g[l][i]] = 1;
                 q.push( g[l][i] );
             }
     }
     if ( gos > maxg )
        maxg = gos;
}

int main()
{
    int i, j, s;
    
    cin >> n;

    for ( i = 1; i <= n; i++ )
    {
        a[i] = 0;
        v[i] = 0;
        g[i][0] = 0;
    }

    for ( i = 1; i <= 20000; i++ )
        b[i] = 0;
    
    for ( i = 1; i <= n; i++ )
    {
        cin >> s;

        a[i] = s;
        b[s] = 1;
    }
    
    for ( i = 1; i <= n; i++ )
        for ( j = i + 1; j <= n; j++ )
            if ( a[i] + a[j] <= 20000 )
                if ( b[a[i] + a[j]] == 1 )
                {
                    g[i][++g[i][0]] = j;
                    g[j][++g[j][0]] = i;
                }
    
    for ( i = 1; i <= n; i++ )
        if ( ! v[i] )
             gossip( i );
             
    cout << maxg << endl;
//    system( "pause" );
}
